Index: sandbox/2.4.2-expresso2/expressoMail1_2/js/common_functions.js
===================================================================
--- sandbox/2.4.2-expresso2/expressoMail1_2/js/common_functions.js	(revision 6787)
+++ sandbox/2.4.2-expresso2/expressoMail1_2/js/common_functions.js	(revision 6795)
@@ -1120,6 +1120,5 @@
 	var main_list = main.childNodes;
 	var len_main_list = main_list.length;
-	var folder = get_current_folder().split(cyrus_delimiter);
-	folder = folder.indexOf('INBOX') != -1 ? get_lang(folder[folder.length - 1]) : folder ;
+	var folder = '"'+$('#content_folders ul.filetree').find('.selected').attr('title')+'"';
 	var div = $('.select-all-messages');	
 	if (select)
@@ -1143,5 +1142,5 @@
 			allMsgsSelected = true;
 			div.html("");
-			var link = "<a class='select-link'>Limpar seleção?</a>";
+			var link = "<a class='select-link' href='#'>Limpar seleção?</a>";
 			var info = "Todas as "+$('#tot_m').text()+" mensagens em "+folder+" foram selecionadas. "+link;
 			div.html("<span>"+info+"<span>");
@@ -1154,5 +1153,5 @@
 		else if (!allMsgsSelected && total_pages > 1){
 			div.html("");
-			var link = "<a class='select-link'>Selecionar todas as "+$('#tot_m').text()+" mensagens em "+folder+"?</a>";
+			var link = "<a class='select-link' href='#'>Selecionar todas as "+$('#tot_m').text()+" mensagens em "+folder+"?</a>";
 			var info = "Todas as "+$('#table_box tr').length+" mensagens desta página foram selecionadas. "+link;
 			div.html("<span>"+info+"<span>");
@@ -1179,5 +1178,5 @@
 		}
 		else if (totalSelected() > 0){
-			var link = "<a class='select-link'>Limpar seleção?</a>";
+			var link = "<a class='select-link' href='#'>Limpar seleção?</a>";
 			var info = "Foram selecionadas "+totalSelected()+" mensagens em "+folder+". "+link;
 			div.html("<span>"+info+"<span>");
Index: sandbox/2.4.2-expresso2/expressoMail1_2/js/draw_api.js
===================================================================
--- sandbox/2.4.2-expresso2/expressoMail1_2/js/draw_api.js	(revision 6787)
+++ sandbox/2.4.2-expresso2/expressoMail1_2/js/draw_api.js	(revision 6795)
@@ -1084,6 +1084,5 @@
 /*Atualiza o array de mensagens selecionadas*/
 function updateSelectedMsgs(selected,msg_number){	
-	var folder = get_current_folder().split(cyrus_delimiter);
-	folder = folder.indexOf('INBOX') != -1 ? get_lang(folder[folder.length - 1]) : folder ;
+	var folder = '"'+$('#content_folders ul.filetree').find('.selected').attr('title')+'"';
 	var div = $('.select-all-messages');
 	/*Seleciona as mensagens ao navegar pelas páginas*/
@@ -1112,8 +1111,8 @@
 	}
 	/*Todas as mensagens selecionadas uma a uma*/
-	if (totalSelected() == parseInt($('#tot_m').text())){
+	if (totalSelected() > 0 && totalSelected() == parseInt($('#tot_m').text())){
 		allMsgsSelected = true;
 		div.html("");
-		var link = "<a class='select-link'>Limpar seleção?</a>";
+		var link = "<a class='select-link' href='#'>Limpar seleção?</a>";
 		var info = "Todas as "+$('#tot_m').text()+" mensagens em "+folder+" foram selecionadas. "+link;
 		div.html("<span>"+info+"<span>");
@@ -1123,5 +1122,5 @@
 	/*Se foram selecionadas algumas mensagens*/
 	else if (totalSelected() > 0 && !allMsgsSelected){
-		var link = "<a class='select-link'>Limpar seleção?</a>";
+		var link = "<a class='select-link' href='#'>Limpar seleção?</a>";
 		var info = "Foram selecionadas "+totalSelected()+" mensagens em "+folder+". "+link;
 		div.html("<span>"+info+"<span>");
@@ -1133,5 +1132,5 @@
 	}
 	else if (allMsgsSelected){
-		var link = "<a class='select-link'>Limpar seleção?</a>";
+		var link = "<a class='select-link' href='#'>Limpar seleção?</a>";
 		var info = "Todas as "+$('#tot_m').text()+" mensagens em "+folder+" foram selecionadas. "+link;
 		div.html("<span>"+info+"<span>");
@@ -1141,4 +1140,7 @@
             $('.select-link').unbind('click');
         });
+	}
+	else{
+		div.hide();
 	} 
     resizeWindow();
@@ -1152,5 +1154,5 @@
 	if (select){
 		allMsgsSelected = true;
-		var link = "<a class='select-link'>Limpar seleção?</a>";
+		var link = "<a class='select-link' href='#'>Limpar seleção?</a>";
 		var info = "Todas as "+$('#tot_m').text()+" mensagens em "+folder+" foram selecionadas. "+link;
 		div.html("<span>"+info+"<span>");